Whamcloud - gitweb
LU-7988 hsm: run HSM coordinator once per second at most
[fs/lustre-release.git] / lustre / tests / sanity-hsm.sh
index f361edc..25c9cf8 100755 (executable)
@@ -11,8 +11,8 @@ SRCDIR=$(dirname $0)
 export PATH=$PWD/$SRCDIR:$SRCDIR:$PWD/$SRCDIR/utils:$PATH:/sbin:/usr/sbin
 
 ONLY=${ONLY:-"$*"}
-# bug number for skipped test:    LU-3815
-ALWAYS_EXCEPT="$SANITY_HSM_EXCEPT 34 35 36"
+# bug number for skipped test:
+ALWAYS_EXCEPT="$SANITY_HSM_EXCEPT"
 # UPDATE THE COMMENT ABOVE WITH BUG NUMBERS WHEN CHANGING ALWAYS_EXCEPT!
 
 LUSTRE=${LUSTRE:-$(cd $(dirname $0)/..; echo $PWD)}
@@ -24,6 +24,7 @@ init_logging
 
 MULTIOP=${MULTIOP:-multiop}
 OPENFILE=${OPENFILE:-openfile}
+MMAP_CAT=${MMAP_CAT:-mmap_cat}
 MOUNT_2=${MOUNT_2:-"yes"}
 FAIL_ON_ERROR=false
 
@@ -102,7 +103,16 @@ init_agt_vars() {
        export HSMTOOL_EVENT_FIFO=${HSMTOOL_EVENT_FIFO:=""}
        export HSMTOOL_TESTDIR
        export HSMTOOL_BASE=$(basename "$HSMTOOL" | cut -f1 -d" ")
+       # $hsm_root/$HSMTMP Makes $hsm_root dir path less generic to ensure
+       # rm -rf $hsm_root/* is safe even if $hsm_root becomes unset to avoid
+       # deleting everything in filesystem, independent of any copytool.
+       export HSMTMP=${HSMTMP:-"shsm"}
+
        HSM_ARCHIVE=$(copytool_device $SINGLEAGT)
+
+       [ -z "${HSM_ARCHIVE// /}" ] && error "HSM_ARCHIVE is empty!"
+       HSM_ARCHIVE=$HSM_ARCHIVE/$HSMTMP
+
        HSM_ARCHIVE_NUMBER=2
 
        # The test only support up to 10 MDTs
@@ -144,15 +154,43 @@ get_mdt_devices() {
 }
 
 search_copytools() {
-       local agents=${1:-$(facet_active_host $SINGLEAGT)}
-       do_nodesv $agents "pgrep -x $HSMTOOL_BASE"
+       local hosts=${1:-$(facet_active_host $SINGLEAGT)}
+       do_nodesv $hosts "pgrep -x $HSMTOOL_BASE"
 }
 
-search_and_kill_copytool() {
-       local agents=${1:-$(facet_active_host $SINGLEAGT)}
+kill_copytools() {
+       local hosts=${1:-$(facet_active_host $SINGLEAGT)}
+
+       echo "Killing existing copytools on $hosts"
+       do_nodesv $hosts "killall -q $HSMTOOL_BASE" || true
+}
+
+wait_copytools() {
+       local hosts=${1:-$(facet_active_host $SINGLEAGT)}
+       local wait_timeout=200
+       local wait_start=$SECONDS
+       local wait_end=$((wait_start + wait_timeout))
+       local sleep_time=100000 # 0.1 second
 
-       echo "Killing existing copytools on $agents"
-       do_nodesv $agents "killall -q $HSMTOOL_BASE" || true
+       while ((SECONDS < wait_end)); do
+               if ! search_copytools $hosts; then
+                       echo "copytools stopped in $((SECONDS - wait_start))s"
+                       return 0
+               fi
+
+               echo "copytools still running on $hosts"
+               usleep $sleep_time
+               [ $sleep_time -lt 32000000 ] && # 3.2 seconds
+                       sleep_time=$(bc <<< "$sleep_time * 2")
+       done
+
+       # try to dump Copytool's stack
+       do_nodesv $hosts "echo 1 >/proc/sys/kernel/sysrq ; " \
+                        "echo t >/proc/sysrq-trigger"
+
+       echo "copytools failed to stop in ${wait_timeout}s"
+
+       return 1
 }
 
 copytool_monitor_setup() {
@@ -218,24 +256,23 @@ copytool_setup() {
        local lustre_mntpnt=${2:-${MOUNT2:-$MOUNT}}
        local arc_id=$3
        local hsm_root=${4:-$(copytool_device $facet)}
-       local agent=$(facet_active_host $facet)
 
-       if [[ -z "$arc_id" ]] &&
-               do_facet $facet "pkill -CONT -x $HSMTOOL_BASE"; then
-                       echo "Only wakeup running copytool $facet on $agent"
-                       return 0
-       fi
+       [ -z "${hsm_root// /}" ] && error "copytool_setup: hsm_root empty!"
+
+       local agent=$(facet_active_host $facet)
 
        if $HSM_ARCHIVE_PURGE; then
                echo "Purging archive on $agent"
-               do_facet $facet "rm -rf $hsm_root/*"
+               do_facet $facet "rm -rf $hsm_root/$HSMTMP/*"
        fi
 
        echo "Starting copytool $facet on $agent"
-       do_facet $facet "mkdir -p $hsm_root" || error "mkdir '$hsm_root' failed"
+       do_facet $facet "mkdir -p $hsm_root/$HSMTMP/" ||
+                       error "mkdir '$hsm_root/$HSMTMP' failed"
        # bandwidth is limited to 1MB/s so the copy time is known and
        # independent of hardware
-       local cmd="$HSMTOOL $HSMTOOL_VERBOSE --daemon --hsm-root $hsm_root"
+       local cmd="$HSMTOOL $HSMTOOL_VERBOSE --daemon"
+       cmd+=" --hsm-root $hsm_root/$HSMTMP"
        [[ -z "$arc_id" ]] || cmd+=" --archive $arc_id"
        [[ -z "$HSMTOOL_UPDATE_INTERVAL" ]] ||
                cmd+=" --update-interval $HSMTOOL_UPDATE_INTERVAL"
@@ -272,54 +309,61 @@ get_copytool_event_log() {
 
 copytool_cleanup() {
        trap - EXIT
-       local facet=$SINGLEAGT
-       local agents=${1:-$(facet_active_host $facet)}
-       local mdtno
-       local idx
-       local oldstate
-       local mdt_hsmctrl
-       local hsm_root=$(copytool_device $facet)
-       local end_wait=$(( SECONDS + TIMEOUT ))
-
-       do_nodesv $agents "pkill -INT -x $HSMTOOL_BASE" || return 0
-
-       while (( SECONDS < end_wait )); do
-               sleep 2
-               do_nodesv $agents "pgrep -x $HSMTOOL_BASE"
-               if [ $? -ne 0 ]; then
-                       echo "Copytool is stopped on $agents"
-                       break
-               fi
-               echo "Copytool still running on $agents"
+       local agt_facet=$SINGLEAGT
+       local agt_hosts=${1:-$(facet_active_host $agt_facet)}
+       local hsm_root=$(copytool_device $agt_facet)
+
+       [ -z "${hsm_root// /}" ] && error "copytool_cleanup: hsm_root empty!"
+
+       local i
+       local facet
+       local param
+       local -a state
+
+       kill_copytools $agt_hosts
+       wait_copytools $agt_hosts || error "copytools failed to stop"
+
+       # Clean all CDTs orphans requests from previous tests that
+       # would otherwise need to timeout to clear.
+       for ((i = 0; i < MDSCOUNT; i++)); do
+               facet=mds$((i + 1))
+               param=$(printf 'mdt.%s-MDT%04x.hsm_control' $FSNAME $i)
+               state[$i]=$(do_facet $facet "$LCTL get_param -n $param")
+
+               # Skip already stopping or stopped CDTs.
+               [[ "${state[$i]}" =~ ^stop ]] && continue
+
+               do_facet $facet "$LCTL set_param $param=shutdown"
        done
-       if do_nodesv $agents "pgrep -x $HSMTOOL_BASE"; then
-               error "Copytool failed to stop in ${TIMEOUT}s ..."
-       else
-               echo "Copytool has stopped in " \
-                    "$((TIMEOUT - (end_wait - SECONDS)))s."
-       fi
 
-       # clean all CDTs orphans requests from previous tests
-       # that would otherwise need to timeout to clear.
-       for mdtno in $(seq 1 $MDSCOUNT); do
-               idx=$(($mdtno - 1))
-               mdt_hsmctrl="mdt.$FSNAME-MDT000${idx}.hsm_control"
-               oldstate=$(do_facet mds${mdtno} "$LCTL get_param -n " \
-                                  "$mdt_hsmctrl")
-               # skip already stop[ed,ing] CDTs
-               echo $oldstate | grep stop && continue
-
-               do_facet mds${mdtno} "$LCTL set_param $mdt_hsmctrl=shutdown"
-               wait_result mds${mdtno} "$LCTL get_param -n $mdt_hsmctrl" \
-                       "stopped" 20 ||
-                       error "mds${mdtno} cdt state is not stopped"
-               do_facet mds${mdtno} "$LCTL set_param $mdt_hsmctrl=$oldstate"
-               wait_result mds${mdtno} "$LCTL get_param -n $mdt_hsmctrl" \
-                       "$oldstate" 20 ||
-                       error "mds${mdtno} cdt state is not $oldstate"
+       for ((i = 0; i < MDSCOUNT; i++)); do
+               # Only check and restore CDTs that we stopped in the first loop.
+               [[ "${state[$i]}" =~ ^stop ]] && continue
+
+               facet=mds$((i + 1))
+               param=$(printf 'mdt.%s-MDT%04x.hsm_control' $FSNAME $i)
+
+               wait_result $facet "$LCTL get_param -n $param" stopped 20 ||
+                       error "$facet CDT state is not stopped"
+
+               # Restore old CDT state.
+               do_facet $facet "$LCTL set_param $param=${state[$i]}"
+       done
+
+       for ((i = 0; i < MDSCOUNT; i++)); do
+               # Only check CDTs that we stopped in the first loop.
+               [[ "${state[$i]}" =~ ^stop ]] && continue
+
+               facet=mds$((i + 1))
+               param=$(printf 'mdt.%s-MDT%04x.hsm_control' $FSNAME $i)
+
+               # Check that the old CDT state was restored.
+               wait_result $facet "$LCTL get_param -n $param" "${state[$i]}" \
+                       20 || error "$facet CDT state is not '${state[$i]}'"
        done
-       if do_facet $facet "df $hsm_root" >/dev/null 2>&1 ; then
-               do_facet $facet "rm -rf $hsm_root/*"
+
+       if do_facet $agt_facet "df $hsm_root" >/dev/null 2>&1 ; then
+               do_facet $agt_facet "rm -rf $hsm_root/$HSMTMP/*"
        fi
 }
 
@@ -330,6 +374,13 @@ copytool_suspend() {
        echo "Copytool is suspended on $agents"
 }
 
+copytool_continue() {
+       local agents=${1:-$(facet_active_host $SINGLEAGT)}
+
+       do_nodesv $agents "pkill -CONT -x $HSMTOOL_BASE" || return 0
+       echo "Copytool is continued on $agents"
+}
+
 copytool_remove_backend() {
        local fid=$1
        local be=$(do_facet $SINGLEAGT find $HSM_ARCHIVE -name $fid)
@@ -634,66 +685,18 @@ check_enough_free_space() {
        return 0
 }
 
-make_large_for_striping() {
-       local file2=${1/$DIR/$DIR2}
-       local sz=$($LCTL get_param -n lov.*-clilov-*.stripesize | head -n1)
-
-       cleanup_large_files
-
-       check_enough_free_space 5 $sz
-       [ $? != 0 ] && return $?
-
-       dd if=/dev/urandom of=$file2 count=5 bs=$sz conv=fsync ||
-               file_creation_failure dd $file2 $?
-
-       path2fid $1 || error "cannot get fid on $1"
-}
-
-make_large_for_progress() {
-       local file2=${1/$DIR/$DIR2}
-
-       cleanup_large_files
-
-       check_enough_free_space 39 1000000
-       [ $? != 0 ] && return $?
-
-       # big file is large enough, so copy time is > 30s
-       # so copytool make 1 progress
-       # size is not a multiple of 1M to avoid stripe
-       # aligment
-       dd if=/dev/urandom of=$file2 count=39 bs=1000000 conv=fsync ||
-               file_creation_failure dd $file2 $?
-
-       path2fid $1 || error "cannot get fid on $1"
-}
-
-make_large_for_progress_aligned() {
+make_custom_file_for_progress() {
        local file2=${1/$DIR/$DIR2}
+       local fsize=${2:-"39"}
+       local blksz=$($LCTL get_param -n lov.*-clilov-*.stripesize | head -n1)
+       blksz=${3:-$blksz}
 
-       cleanup_large_files
-
-       check_enough_free_space 33 1048576
-       [ $? != 0 ] && return $?
-
-       # big file is large enough, so copy time is > 30s
-       # so copytool make 1 progress
-       # size is a multiple of 1M to have stripe
-       # aligment
-       dd if=/dev/urandom of=$file2 count=33 bs=1M conv=fsync ||
-               file_creation_failure dd $file2 $?
-       path2fid $1 || error "cannot get fid on $1"
-}
-
-make_large_for_cancel() {
-       local file2=${1/$DIR/$DIR2}
+       [[ $fsize -gt  0 ]] || error "Invalid file size"
+       [[ $blksz -gt 0 ]] || error "Invalid stripe size"
 
        cleanup_large_files
-
-       check_enough_free_space 103 1048576
-       [ $? != 0 ] && return $?
-
-       # Copy timeout is 100s. 105MB => 105s
-       dd if=/dev/urandom of=$file2 count=103 bs=1M conv=fsync ||
+       check_enough_free_space $fsize $blksz || return $?
+       dd if=/dev/zero of=$file2 count=$fsize bs=$blksz conv=fsync ||
                file_creation_failure dd $file2 $?
        path2fid $1 || error "cannot get fid on $1"
 }
@@ -735,6 +738,15 @@ get_request_count() {
                "awk -vn=0 '/'$fid'.*action='$request'/ {n++}; END {print n}'"
 }
 
+# Ensure the number of HSM request for a given FID is correct
+# assert_request_count FID REQUEST_TYPE COUNT [ERROR_MSG]
+assert_request_count() {
+       local request_count=$(get_request_count $1 $2)
+       local default_error_msg=("expected $3 '$2' request(s) for '$1', found "
+                               "'$request_count'")
+       [ $request_count -eq $3 ] || error "${4:-"${default_error_msg[@]}"}"
+}
+
 wait_all_done() {
        local timeout=$1
        local fid=$2
@@ -752,6 +764,11 @@ wait_for_grace_delay() {
        sleep $val
 }
 
+wait_for_loop_period() {
+       local val=$(get_hsm_param loop_period)
+       sleep $val
+}
+
 parse_json_event() {
        local raw_event=$1
 
@@ -764,14 +781,74 @@ parse_json_event() {
        echo $raw_event | python -c "$json_parser"
 }
 
-# populate MDT device array
-get_mdt_devices
+get_agent_by_uuid_mdt() {
+       local uuid=$1
+       local mdtidx=$2
+       local mds=mds$(($mdtidx + 1))
+       do_facet $mds "$LCTL get_param -n ${MDT_PREFIX}${mdtidx}.hsm.agents |\
+                grep $uuid"
+}
+
+check_agent_registered_by_mdt() {
+       local uuid=$1
+       local mdtidx=$2
+       local mds=mds$(($mdtidx + 1))
+       local agent=$(get_agent_by_uuid_mdt $uuid $mdtidx)
+       if [[ ! -z "$agent" ]]; then
+               echo "found agent $agent on $mds"
+       else
+               error "uuid $uuid not found in agent list on $mds"
+       fi
+}
+
+check_agent_unregistered_by_mdt() {
+       local uuid=$1
+       local mdtidx=$2
+       local mds=mds$(($mdtidx + 1))
+       local agent=$(get_agent_by_uuid_mdt $uuid $mdtidx)
+       if [[ -z "$agent" ]]; then
+               echo "uuid not found in agent list on $mds"
+       else
+               error "uuid found in agent list on $mds: $agent"
+       fi
+}
+
+check_agent_registered() {
+       local uuid=$1
+       local mdsno
+       for mdsno in $(seq 1 $MDSCOUNT); do
+               check_agent_registered_by_mdt $uuid $((mdsno - 1))
+       done
+}
+
+check_agent_unregistered() {
+       local uuid=$1
+       local mdsno
+       for mdsno in $(seq 1 $MDSCOUNT); do
+               check_agent_unregistered_by_mdt $uuid $((mdsno - 1))
+       done
+}
+
+get_agent_uuid() {
+       local agent=${1:-$(facet_active_host $SINGLEAGT)}
+
+       # Lustre mount-point is mandatory and last parameter on
+       # copytool cmd-line.
+       local mntpnt=$(do_rpc_nodes $agent ps -C $HSMTOOL_BASE -o args= |
+                      awk '{print $NF}')
+       [ -n "$mntpnt" ] || error "Found no Agent or with no mount-point "\
+                                 "parameter"
+       do_rpc_nodes $agent get_client_uuid $mntpnt | cut -d' ' -f2
+}
 
 # initiate variables
 init_agt_vars
 
+# populate MDT device array
+get_mdt_devices
+
 # cleanup from previous bad setup
-search_and_kill_copytool
+kill_copytools
 
 # for recovery tests, coordinator needs to be started at mount
 # so force it
@@ -780,9 +857,6 @@ echo "Set HSM on and start"
 cdt_set_mount_state enabled
 cdt_check_state enabled
 
-echo "Start copytool"
-copytool_setup
-
 echo "Set sanity-hsm HSM policy"
 cdt_set_sanity_policy
 
@@ -824,6 +898,59 @@ test_1() {
 }
 run_test 1 "lfs hsm flags root/non-root access"
 
+test_1a() {
+       mkdir -p $DIR/$tdir
+       local f=$DIR/$tdir/$tfile
+       local fid=$(make_small $f)
+
+       copytool_setup
+
+       $LFS hsm_archive $f || error "could not archive file"
+       wait_request_state $fid ARCHIVE SUCCEED
+
+       # Release and check states
+       $LFS hsm_release $f || error "could not release file"
+       echo -n "Verifying released state: "
+       check_hsm_flags $f "0x0000000d"
+
+       $MMAP_CAT $f > /dev/null || error "failed mmap & cat release file"
+
+       copytool_cleanup
+}
+run_test 1a "mmap & cat a HSM released file"
+
+test_1b() {
+       mkdir -p $DIR/$tdir
+       $LFS setstripe -E 1M -E 64M -c 2 -E -1 -c 4 $DIR/$tdir ||
+               error "failed to set default stripe"
+       local f=$DIR/$tdir/$tfile
+       rm -f $f
+
+       dd if=/dev/random of=$f bs=1M count=1 conv=sync ||
+               error "failed to create file"
+       local fid=$(path2fid $f)
+
+       copytool_setup
+
+       echo "archive $f"
+       $LFS hsm_archive $f || error "could not archive file"
+       wait_request_state $fid ARCHIVE SUCCEED
+
+       echo "release $f"
+       $LFS hsm_release $f || error "could not release file"
+       echo "verify released state: "
+       check_hsm_flags $f "0x0000000d" && echo "pass"
+
+       echo "restore $f"
+       $LFS hsm_restore $f || error "could not restore file"
+       wait_request_state $fid RESTORE SUCCEED
+       echo "verify restored state: "
+       check_hsm_flags $f "0x00000009" && echo "pass"
+
+       copytool_cleanup
+}
+run_test 1b "Archive, Release & Restore composite file"
+
 test_2() {
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
@@ -935,13 +1062,19 @@ test_8() {
 run_test 8 "Test default archive number"
 
 test_9() {
-       mkdir -p $DIR/$tdir
-       local f=$DIR/$tdir/$tfile
-       local fid=$(copy_file /etc/passwd $f)
        # we do not use the default one to be sure
        local new_an=$((HSM_ARCHIVE_NUMBER + 1))
        copytool_cleanup
        copytool_setup $SINGLEAGT $MOUNT $new_an
+
+       # give time for CT to register with MDTs
+       sleep $(($MDSCOUNT*2))
+       local uuid=$(get_agent_uuid $(facet_active_host $SINGLEAGT))
+       check_agent_registered $uuid
+
+       mkdir -p $DIR/$tdir
+       local f=$DIR/$tdir/$tfile
+       local fid=$(copy_file /etc/passwd $f)
        $LFS hsm_archive --archive $new_an $f
        wait_request_state $fid ARCHIVE SUCCEED
 
@@ -1175,7 +1308,7 @@ test_12c() {
        local f=$DIR/$tdir/$tfile
        $LFS setstripe -c 2 $f
        local fid
-       fid=$(make_large_for_striping $f)
+       fid=$(make_custom_file_for_progress $f 5)
        [ $? != 0 ] && skip "not enough free space" && return
 
        local FILE_CRC=$(md5sum $f)
@@ -1454,9 +1587,8 @@ test_12q() {
        $LFS hsm_release $f || error "could not release file"
        check_hsm_flags $f "0x0000000d"
 
-       search_and_kill_copytool
-       sleep 5
-       search_copytools && error "Copytool should have stopped"
+       kill_copytools
+       wait_copytools || error "copytool failed to stop"
 
        cat $f > /dev/null &
 
@@ -1641,9 +1773,10 @@ test_16() {
        $LFS hsm_archive $f
        wait_request_state $fid ARCHIVE SUCCEED
        local end=$(date +%s)
-       local duration=$((end - start))
+       # Add 1 to account for rounding errors between start and end (LU-8155)
+       local duration=$((end - start + 1))
 
-       [[ $duration -ge $goal ]] ||
+       [[ $duration -ge $((goal - 1)) ]] ||
                error "Transfer is too fast $duration < $goal"
 
        copytool_cleanup
@@ -1875,8 +2008,7 @@ test_24a() {
        [ $ctime0 -eq $ctime1 ] ||
                error "release changed ctime from $ctime0 to $ctime1"
 
-       # Restore should not change atime or mtime and should not
-       # decrease ctime.
+       # Restore should not change any timestamps.
        $LFS hsm_restore $file
        wait_request_state $fid RESTORE SUCCEED
 
@@ -2003,7 +2135,6 @@ test_24c() {
        chown $RUNAS_ID:nobody $file ||
                error "cannot chown '$file' to '$RUNAS_ID:nobody'"
 
-       set_hsm_param user_request_mask ""
        $RUNAS $LFS hsm_$action $file &&
                error "$action by user should fail"
 
@@ -2017,7 +2148,6 @@ test_24c() {
        chown nobody:$RUNAS_GID $file ||
                error "cannot chown '$file' to 'nobody:$RUNAS_GID'"
 
-       set_hsm_param group_request_mask ""
        $RUNAS $LFS hsm_$action $file &&
                error "$action by group should fail"
 
@@ -2031,7 +2161,6 @@ test_24c() {
        chown nobody:nobody $file ||
                error "cannot chown '$file' to 'nobody:nobody'"
 
-       set_hsm_param other_request_mask ""
        $RUNAS $LFS hsm_$action $file &&
                error "$action by other should fail"
 
@@ -2047,6 +2176,7 @@ run_test 24c "check that user,group,other request masks work"
 cleanup_test_24d() {
        trap 0
        mount -o remount,rw $MOUNT2
+       zconf_umount $(facet_host $SINGLEAGT) "$MOUNT3"
 }
 
 test_24d() {
@@ -2055,16 +2185,24 @@ test_24d() {
        local fid1
        local fid2
 
-       copytool_setup
-
        mkdir -p $DIR/$tdir
        rm -f $file1
        fid1=$(make_small $file1)
 
+       echo $fid1
+       $LFS getstripe $file1
+
        trap cleanup_test_24d EXIT
+       zconf_mount $(facet_host $SINGLEAGT) "$MOUNT3" ||
+               error "cannot mount '$MOUNT3' on '$SINGLEAGT'"
+       copytool_setup $SINGLEAGT "$MOUNT3" ||
+               error "unable to setup a copytool for the test"
 
        mount -o remount,ro $MOUNT2
 
+       do_nodes $(comma_list $(nodes_list)) $LCTL clear
+       start_full_debug_logging
+
        fid2=$(path2fid $file2)
        [ "$fid1" == "$fid2" ] ||
                error "FID mismatch '$fid1' != '$fid2'"
@@ -2073,15 +2211,17 @@ test_24d() {
                error "archive should fail on read-only mount"
        check_hsm_flags $file1 "0x00000000"
 
-       $LFS hsm_archive $file1
+       $LFS hsm_archive $file1 || error "Fail to archive $file1"
        wait_request_state $fid1 ARCHIVE SUCCEED
 
+       stop_full_debug_logging
+
        $LFS hsm_release $file1
        $LFS hsm_restore $file2
        wait_request_state $fid1 RESTORE SUCCEED
 
        $LFS hsm_release $file1 || error "cannot release '$file1'"
-       dd if=$file2 of=/dev/null bs=1M || "cannot read '$file2'"
+       dd if=$file2 of=/dev/null bs=1M || error "cannot read '$file2'"
 
        $LFS hsm_release $file2 &&
                error "release should fail on read-only mount"
@@ -2194,7 +2334,7 @@ test_26() {
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
        local fid
-       fid=$(make_large_for_progress $f)
+       fid=$(make_custom_file_for_progress $f 39 1000000)
        [ $? != 0 ] && skip "not enough free space" && return
 
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
@@ -2209,67 +2349,283 @@ test_26() {
 }
 run_test 26 "Remove the archive of a valid file"
 
-test_27a() {
-       # test needs a running copytool
-       copytool_setup
-
-       mkdir -p $DIR/$tdir
-       make_archive $tdir/$tfile
-       local f=$DIR/$tdir/$tfile
-       import_file $tdir/$tfile $f
-       local fid=$(path2fid $f)
-
-       $LFS hsm_remove $f
-
-       [[ $? != 0 ]] || error "Remove of a released file should fail"
-
+cleanup_test_26a() {
+       trap 0
+       set_hsm_param remove_archive_on_last_unlink 0
+       set_hsm_param loop_period $orig_loop_period
+       set_hsm_param grace_delay $orig_grace_delay
        copytool_cleanup
 }
-run_test 27a "Remove the archive of an imported file (Operation not permitted)"
 
-test_27b() {
+test_26a() {
+       local raolu=$(get_hsm_param remove_archive_on_last_unlink)
+       [[ $raolu -eq 0 ]] || error "RAoLU policy should be off"
+
        # test needs a running copytool
        copytool_setup
 
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
-       local fid
-       fid=$(make_large_for_progress $f)
-       [ $? != 0 ] && skip "not enough free space" && return
+       local fid=$(copy_file /etc/passwd $f)
 
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
        wait_request_state $fid ARCHIVE SUCCEED
-       $LFS hsm_release $f
 
-       $LFS hsm_remove $f
+       local f2=$DIR/$tdir/${tfile}_2
+       local fid2=$(copy_file /etc/passwd $f2)
 
-       [[ $? != 0 ]] || error "Remove of a released file should fail"
+       $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f2
+       wait_request_state $fid2 ARCHIVE SUCCEED
+
+       local f3=$DIR/$tdir/${tfile}_3
+       local fid3=$(copy_file /etc/passwd $f3)
 
+       $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f3
+       wait_request_state $fid3 ARCHIVE SUCCEED
+
+       trap cleanup_test_26a EXIT
+
+       # set a long grace_delay vs short loop_period
+       local orig_loop_period=$(get_hsm_param loop_period)
+       local orig_grace_delay=$(get_hsm_param grace_delay)
+       set_hsm_param loop_period 10
+       set_hsm_param grace_delay 100
+
+       rm -f $f
+
+       set_hsm_param remove_archive_on_last_unlink 1
+
+       ln "$f3" "$f3"_bis || error "Unable to create hard-link"
+       rm -f $f3
+
+       rm -f $f2
+
+       set_hsm_param remove_archive_on_last_unlink 0
+
+       wait_request_state $fid2 REMOVE SUCCEED
+
+       assert_request_count $fid REMOVE 0 \
+               "Unexpected archived data remove request for $f"
+       assert_request_count $fid3 REMOVE 0 \
+               "Unexpected archived data remove request for $f3"
+
+       cleanup_test_26a
+}
+run_test 26a "Remove Archive On Last Unlink (RAoLU) policy"
+
+cleanup_test_26b() {
+       trap 0
+       set_hsm_param remove_archive_on_last_unlink 0
        copytool_cleanup
 }
-run_test 27b "Remove the archive of a relased file (Operation not permitted)"
 
-test_28() {
+test_26b() {
+
        # test needs a running copytool
        copytool_setup
 
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
-       local fid
-       fid=$(make_large_for_progress $f)
-       [ $? != 0 ] && skip "not enough free space" && return
+       local fid=$(copy_file /etc/passwd $f)
 
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
        wait_request_state $fid ARCHIVE SUCCEED
 
-       cdt_disable
-       $LFS hsm_remove $f
+       trap cleanup_test_26b EXIT
+
+       set_hsm_param remove_archive_on_last_unlink 1
+
+       cdt_shutdown
+       cdt_check_state stopped
 
        rm -f $f
 
-       cdt_enable
+       set_hsm_param remove_archive_on_last_unlink 0
 
-       wait_request_state $fid REMOVE SUCCEED
+       wait_request_state $fid REMOVE WAITING
+
+       cdt_enable
+       # copytool must re-register
+       kill_copytools
+       wait_copytools || error "copytool failed to stop"
+       HSM_ARCHIVE_PURGE=false copytool_setup
+
+       wait_request_state $fid REMOVE SUCCEED
+
+       cleanup_test_26b
+}
+run_test 26b "RAoLU policy when CDT off"
+
+cleanup_test_26c() {
+       trap 0
+       set_hsm_param remove_archive_on_last_unlink 0
+       set_hsm_param loop_period $orig_loop_period
+       set_hsm_param grace_delay $orig_grace_delay
+       copytool_cleanup
+}
+
+test_26c() {
+
+       # test needs a running copytool
+       copytool_setup
+
+       mkdir -p $DIR/$tdir
+       local f=$DIR/$tdir/$tfile
+       local fid=$(copy_file /etc/passwd $f)
+
+       $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
+       wait_request_state $fid ARCHIVE SUCCEED
+
+       local f2=$DIR/$tdir/${tfile}_2
+       local fid2=$(copy_file /etc/passwd $f2)
+
+       $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f2
+       wait_request_state $fid2 ARCHIVE SUCCEED
+
+       trap cleanup_test_26c EXIT
+
+       # set a long grace_delay vs short loop_period
+       local orig_loop_period=$(get_hsm_param loop_period)
+       local orig_grace_delay=$(get_hsm_param grace_delay)
+       set_hsm_param loop_period 10
+       set_hsm_param grace_delay 100
+
+       set_hsm_param remove_archive_on_last_unlink 1
+
+       multiop_bg_pause $f O_c || error "open $f failed"
+       local pid=$!
+
+       rm -f $f
+       rm -f $f2
+
+       wait_request_state $fid2 REMOVE SUCCEED
+       assert_request_count $fid REMOVE 0 \
+               "Unexpected archived data remove request for $f"
+
+       kill -USR1 $pid || error "multiop early exit"
+       # should reach autotest timeout if multiop fails to trap
+       # signal, close file, and exit ...
+       wait $pid || error
+
+       set_hsm_param remove_archive_on_last_unlink 0
+
+       wait_request_state $fid REMOVE SUCCEED
+
+       cleanup_test_26c
+}
+run_test 26c "RAoLU effective when file closed"
+
+cleanup_test_26d() {
+       trap 0
+       set_hsm_param remove_archive_on_last_unlink 0
+       set_hsm_param loop_period $orig_loop_period
+       set_hsm_param grace_delay $orig_grace_delay
+       copytool_cleanup
+}
+
+test_26d() {
+
+       # test needs a running copytool
+       copytool_setup
+
+       mkdir -p $DIR/$tdir
+       local f=$DIR/$tdir/$tfile
+       local fid=$(copy_file /etc/motd $f 1)
+
+       $LFS hsm_archive $f || error "could not archive file"
+       wait_request_state $fid ARCHIVE SUCCEED
+
+       trap cleanup_test_26d EXIT
+
+       # set a long grace_delay vs short loop_period
+       local orig_loop_period=$(get_hsm_param loop_period)
+       local orig_grace_delay=$(get_hsm_param grace_delay)
+       set_hsm_param loop_period 10
+       set_hsm_param grace_delay 100
+
+       set_hsm_param remove_archive_on_last_unlink 1
+
+       multiop_bg_pause $f O_c || error "multiop failed"
+       local MULTIPID=$!
+
+       rm -f $f
+
+       mds_evict_client
+
+       set_hsm_param remove_archive_on_last_unlink 0
+
+       wait_request_state $fid REMOVE SUCCEED
+
+       client_up || client_up || true
+
+       kill -USR1 $MULTIPID
+       wait $MULTIPID || error "multiop close failed"
+
+       cleanup_test_26d
+}
+run_test 26d "RAoLU when Client eviction"
+
+test_27a() {
+       # test needs a running copytool
+       copytool_setup
+
+       mkdir -p $DIR/$tdir
+       make_archive $tdir/$tfile
+       local f=$DIR/$tdir/$tfile
+       import_file $tdir/$tfile $f
+       local fid=$(path2fid $f)
+
+       $LFS hsm_remove $f
+
+       [[ $? != 0 ]] || error "Remove of a released file should fail"
+
+       copytool_cleanup
+}
+run_test 27a "Remove the archive of an imported file (Operation not permitted)"
+
+test_27b() {
+       # test needs a running copytool
+       copytool_setup
+
+       mkdir -p $DIR/$tdir
+       local f=$DIR/$tdir/$tfile
+       local fid
+       fid=$(make_custom_file_for_progress $f 39 1000000)
+       [ $? != 0 ] && skip "not enough free space" && return
+
+       $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
+       wait_request_state $fid ARCHIVE SUCCEED
+       $LFS hsm_release $f
+
+       $LFS hsm_remove $f
+
+       [[ $? != 0 ]] || error "Remove of a released file should fail"
+
+       copytool_cleanup
+}
+run_test 27b "Remove the archive of a relased file (Operation not permitted)"
+
+test_28() {
+       # test needs a running copytool
+       copytool_setup
+
+       mkdir -p $DIR/$tdir
+       local f=$DIR/$tdir/$tfile
+       local fid
+       fid=$(make_custom_file_for_progress $f 39 1000000)
+       [ $? != 0 ] && skip "not enough free space" && return
+
+       $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
+       wait_request_state $fid ARCHIVE SUCCEED
+
+       cdt_disable
+       $LFS hsm_remove $f
+
+       rm -f $f
+
+       cdt_enable
+
+       wait_request_state $fid REMOVE SUCCEED
 
        copytool_cleanup
 }
@@ -2345,6 +2701,78 @@ test_29c() {
 }
 run_test 29c "Archive/delete/remove by FID, using a file list."
 
+test_29d() {
+       # test needs more than one CT
+       needclients 3 || return 0
+
+       local n
+       local file
+       local fid
+
+       copytool_cleanup $(comma_list $(agts_nodes))
+
+       # start all of the copytools
+       for n in $(seq $AGTCOUNT); do
+               copytool_setup agt$n $MOUNT2 $n
+       done
+
+       trap "copytool_cleanup $(comma_list $(agts_nodes))" EXIT
+       # archive files
+       mkdir -p $DIR/$tdir
+       file=$DIR/$tdir/$tfile
+       fid=$(make_small $file)
+
+       $LFS hsm_archive $file
+       wait_request_state $fid ARCHIVE SUCCEED
+       check_hsm_flags $file "0x00000009"
+
+       rm -f $file
+
+       $LFS hsm_remove --mntpath "$MOUNT" -a 0 $fid ||
+               error "cannot hsm_remove '$fid'"
+
+       # give time for CDT to handle remove request and create broadcasted
+       sleep 2
+
+       # remove request has been broadcasted ?
+       local cnt=$(get_request_count $fid REMOVE)
+       # broadcasted requests + original
+       [[ $cnt -eq $((AGTCOUNT + 1)) ]] ||
+               error "remove not broadcasted to all CTs"
+
+       # give time for CDT and CTs to handle broadcasted
+       wait_for_loop_period
+
+       # each agent serves one different archive_id, so broadcasted
+       # hsm_remove request should only succeed once and fail at all others
+       local res
+       local scnt=0
+       local fcnt=0
+       for n in $(seq $AGTCOUNT); do
+               res=$(do_facet $SINGLEMDS "$LCTL get_param -n \
+                              $HSM_PARAM.actions | awk \
+                              '/'$fid'.*action=REMOVE archive#='$n'/ \
+                              {print \\\$13}' | cut -f2 -d=")
+               if [[ "$res" == "SUCCEED" ]]; then
+                       scnt=$((scnt + 1))
+               elif [[ "$res" == "FAILED" ]]; then
+                       fcnt=$((fcnt + 1))
+               fi
+       done
+
+       [[ $scnt -ne 1 ]] &&
+               error "one and only CT should have removed successfully"
+
+       [[ $AGTCOUNT -ne $((scnt + fcnt)) ]] &&
+               error "all but one CT should have failed to remove"
+
+       trap - EXIT
+       copytool_cleanup $(comma_list $(agts_nodes))
+
+}
+run_test 29d "hsm_remove by FID with archive_id 0 for unlinked file cause "\
+            "request to be sent once for each registered archive_id"
+
 test_30a() {
        # restore at exec cannot work on agent node (because of Linux kernel
        # protection of executables)
@@ -2462,19 +2890,18 @@ restore_and_check_size() {
        while [[ "$st" != "0x00000009" && $cpt -le 10 ]]
        do
                n=$(stat -c "%s" $f)
-               # we echo in both cases to show stat is not
-               # hang
+               # we echo in both cases to show stat is not hang
                if [[ $n != $s ]]; then
                        echo "size seen is $n != $s"
                        err=1
                else
                        echo "size seen is right: $n == $s"
                fi
-               st=$(get_hsm_flags $f)
                sleep 10
                cpt=$((cpt + 1))
+               st=$(get_hsm_flags $f)
        done
-       if [[ $cpt -lt 10 ]]; then
+       if [[ "$st" = "0x00000009" ]]; then
                echo " "done
        else
                echo " restore is too long"
@@ -2513,7 +2940,7 @@ test_31b() {
 
        local f=$DIR/$tdir/$tfile
        local fid
-       fid=$(make_large_for_progress $f)
+       fid=$(make_custom_file_for_progress $f 39 1000000)
        [ $? != 0 ] && skip "not enough free space" && return
 
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
@@ -2537,7 +2964,7 @@ test_31c() {
 
        local f=$DIR/$tdir/$tfile
        local fid
-       fid=$(make_large_for_progress_aligned $f)
+       fid=$(make_custom_file_for_progress $f 33 1048576)
        [ $? != 0 ] && skip "not enough free space" && return
 
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
@@ -2561,7 +2988,7 @@ test_33() {
 
        local f=$DIR/$tdir/$tfile
        local fid
-       fid=$(make_large_for_progress $f)
+       fid=$(make_custom_file_for_progress $f 39 1000000)
        [ $? != 0 ] && skip "not enough free space" && return
 
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
@@ -2628,7 +3055,7 @@ test_34() {
 
        local f=$DIR/$tdir/$tfile
        local fid
-       fid=$(make_large_for_progress $f)
+       fid=$(make_custom_file_for_progress $f 39 1000000)
        [ $? != 0 ] && skip "not enough free space" && return
 
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
@@ -2664,7 +3091,7 @@ test_35() {
        local f=$DIR/$tdir/$tfile
        local f1=$DIR/$tdir/$tfile-1
        local fid
-       fid=$(make_large_for_progress $f)
+       fid=$(make_custom_file_for_progress $f 39 1000000)
        [ $? != 0 ] && skip "not enough free space" && return
 
        local fid1=$(copy_file /etc/passwd $f1)
@@ -2703,7 +3130,7 @@ test_36() {
 
        local f=$DIR/$tdir/$tfile
        local fid
-       fid=$(make_large_for_progress $f)
+       fid=$(make_custom_file_for_progress $f 39 1000000)
        [ $? != 0 ] && skip "not enough free space" && return
 
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
@@ -2747,6 +3174,9 @@ test_37() {
        wait_request_state $fid ARCHIVE SUCCEED
        $LFS hsm_release $f || error "cannot release $f"
 
+       # Allow previous archive request to expire from the actions log.
+       wait_for_grace_delay
+
        # Dirty file.
        dd if=/dev/urandom of=$f bs=1M count=1 || error "cannot dirty file"
 
@@ -2768,6 +3198,12 @@ multi_archive() {
        echo "$count archive requests submitted"
 }
 
+cleanup_test_40() {
+       trap 0
+       set_hsm_param max_requests $max_requests
+       copytool_cleanup
+}
+
 test_40() {
        local stream_count=4
        local file_count=100
@@ -2776,6 +3212,17 @@ test_40() {
        local i=""
        local p=""
        local fid=""
+       local max_requests=$(get_hsm_param max_requests)
+
+       # Increase the number of HSM request that can be performed in
+       # parallel. With the coordinator running once per second, this
+       # also limits the number of requests per seconds that can be
+       # performed, so we pick a decent number. But we also need to keep
+       # that number low because the copytool has no rate limit and will
+       # fail some requests if if gets too many at once.
+       set_hsm_param max_requests 300
+
+       trap cleanup_test_40 EXIT
 
        for i in $(seq 1 $file_count); do
                for p in $(seq 1 $stream_count); do
@@ -2802,7 +3249,8 @@ test_40() {
        wait ${pids[*]}
        echo OK
        wait_all_done 100
-       copytool_cleanup
+
+       cleanup_test_40
 }
 run_test 40 "Parallel archive requests"
 
@@ -2867,7 +3315,7 @@ test_54() {
 
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_progress $f)
+       local fid=$(make_custom_file_for_progress $f 39 1000000)
 
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f ||
                error "could not archive file"
@@ -2895,7 +3343,7 @@ test_55() {
 
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_progress $f)
+       local fid=$(make_custom_file_for_progress $f 39 1000000)
 
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f ||
                error "could not archive file"
@@ -2924,7 +3372,7 @@ test_56() {
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
        local fid
-       fid=$(make_large_for_progress $f)
+       fid=$(make_custom_file_for_progress $f 39 1000000)
        [ $? != 0 ] && skip "not enough free space" && return
 
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f ||
@@ -3065,7 +3513,7 @@ test_60() {
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
        local fid
-       fid=$(make_large_for_progress $f)
+       fid=$(make_custom_file_for_progress $f 10)
        [ $? != 0 ] && skip "not enough free space" && return
 
        local mdtidx=0
@@ -3116,15 +3564,36 @@ test_60() {
        local elapsed=$((finish_at - start_at))
 
        # Ensure that the progress update occurred within the expected window.
-       if [ $elapsed -lt $interval ]; then
+       if [ $elapsed -lt $((interval - 1)) ]; then
                error "Expected progress update after at least $interval seconds"
        fi
 
+       echo "Wait for on going archive hsm action to complete"
+       wait_update $agent "grep -o copied $copytool_log" "copied" 10 ||
+               echo "File archiving not completed even after 10 secs"
+
        cdt_clear_no_retry
        copytool_cleanup
 }
 run_test 60 "Changing progress update interval from default"
 
+test_61() {
+       # test needs a running copytool
+       copytool_setup
+
+       mkdir -p $DIR/$tdir
+       local f=$DIR/$tdir/$tfile
+       local fid=$(copy_file /etc/passwd $f)
+       cdt_disable
+       $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
+       rm -f $f
+       cdt_enable
+       wait_request_state $fid ARCHIVE FAILED
+
+       copytool_cleanup
+}
+run_test 61 "Waiting archive of a removed file should fail"
+
 test_70() {
        # test needs a new running copytool
        copytool_cleanup
@@ -3184,7 +3653,7 @@ test_71() {
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
        local fid
-       fid=$(make_large_for_progress $f)
+       fid=$(make_custom_file_for_progress $f 39 1000000)
        [ $? != 0 ] && skip "not enough free space" && return
 
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f ||
@@ -3456,34 +3925,45 @@ run_test 103 "Purge all requests"
 DATA=CEA
 DATAHEX='[434541]'
 test_104() {
-       # test needs a running copytool
-       copytool_setup
 
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
        local fid
-       fid=$(make_large_for_progress $f)
+       fid=$(make_custom_file_for_progress $f 39 1000000)
        [ $? != 0 ] && skip "not enough free space" && return
 
-       # if cdt is on, it can serve too quickly the request
-       cdt_disable
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER --data $DATA $f
        local data1=$(do_facet $SINGLEMDS "$LCTL get_param -n\
                        $HSM_PARAM.actions |\
                        grep $fid | cut -f16 -d=")
-       cdt_enable
 
        [[ "$data1" == "$DATAHEX" ]] ||
                error "Data field in records is ($data1) and not ($DATAHEX)"
 
+       # archive the file
+       copytool_setup
+
+       wait_request_state $fid ARCHIVE SUCCEED
+
        copytool_cleanup
 }
 run_test 104 "Copy tool data field"
 
+cleanup_test_105() {
+       trap 0
+       set_hsm_param max_requests $max_requests
+       copytool_cleanup
+}
+
 test_105() {
+       local max_requests=$(get_hsm_param max_requests)
        mkdir -p $DIR/$tdir
        local i=""
 
+       set_hsm_param max_requests 300
+
+       trap cleanup_test_105 EXIT
+
        cdt_disable
        for i in $(seq -w 1 10); do
                cp /etc/passwd $DIR/$tdir/$i
@@ -3493,6 +3973,7 @@ test_105() {
                        $HSM_PARAM.actions |\
                        grep WAITING | wc -l")
        cdt_restart
+
        cdt_disable
        local reqcnt2=$(do_facet $SINGLEMDS "$LCTL get_param -n\
                        $HSM_PARAM.actions |\
@@ -3502,68 +3983,10 @@ test_105() {
        [[ "$reqcnt1" == "$reqcnt2" ]] ||
                error "Requests count after shutdown $reqcnt2 != "\
                      "before shutdown $reqcnt1"
-}
-run_test 105 "Restart of coordinator"
 
-get_agent_by_uuid_mdt() {
-       local uuid=$1
-       local mdtidx=$2
-       local mds=mds$(($mdtidx + 1))
-       do_facet $mds "$LCTL get_param -n ${MDT_PREFIX}${mdtidx}.hsm.agents |\
-                grep $uuid"
-}
-
-check_agent_registered_by_mdt() {
-       local uuid=$1
-       local mdtidx=$2
-       local mds=mds$(($mdtidx + 1))
-       local agent=$(get_agent_by_uuid_mdt $uuid $mdtidx)
-       if [[ ! -z "$agent" ]]; then
-               echo "found agent $agent on $mds"
-       else
-               error "uuid $uuid not found in agent list on $mds"
-       fi
-}
-
-check_agent_unregistered_by_mdt() {
-       local uuid=$1
-       local mdtidx=$2
-       local mds=mds$(($mdtidx + 1))
-       local agent=$(get_agent_by_uuid_mdt $uuid $mdtidx)
-       if [[ -z "$agent" ]]; then
-               echo "uuid not found in agent list on $mds"
-       else
-               error "uuid found in agent list on $mds: $agent"
-       fi
-}
-
-check_agent_registered() {
-       local uuid=$1
-       local mdsno
-       for mdsno in $(seq 1 $MDSCOUNT); do
-               check_agent_registered_by_mdt $uuid $((mdsno - 1))
-       done
-}
-
-check_agent_unregistered() {
-       local uuid=$1
-       local mdsno
-       for mdsno in $(seq 1 $MDSCOUNT); do
-               check_agent_unregistered_by_mdt $uuid $((mdsno - 1))
-       done
-}
-
-get_agent_uuid() {
-       local agent=${1:-$(facet_active_host $SINGLEAGT)}
-
-       # Lustre mount-point is mandatory and last parameter on
-       # copytool cmd-line.
-       local mntpnt=$(do_rpc_nodes $agent pgrep -fl $HSMTOOL_BASE |
-                      grep -v pgrep | awk '{print $NF}')
-       [ -n "$mntpnt" ] || error "Found no Agent or with no mount-point "\
-                                 "parameter"
-       do_rpc_nodes $agent get_client_uuid $mntpnt | cut -d' ' -f2
+       cleanup_test_105
 }
+run_test 105 "Restart of coordinator"
 
 test_106() {
        # test needs a running copytool
@@ -3790,7 +4213,7 @@ test_200() {
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
        local fid
-       fid=$(make_large_for_cancel $f)
+       fid=$(make_custom_file_for_progress $f 103 1048576)
        [ $? != 0 ] && skip "not enough free space" && return
 
        # test with cdt on is made in test_221
@@ -3838,7 +4261,7 @@ test_202() {
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
        local fid
-       fid=$(make_large_for_progress $f)
+       fid=$(make_custom_file_for_progress $f 39 1000000)
        [ $? != 0 ] && skip "not enough free space" && return
 
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
@@ -3880,6 +4303,43 @@ test_220() {
 }
 run_test 220 "Changelog for archive"
 
+test_220a() {
+       # test needs a running copytool
+       copytool_setup
+
+       mkdir -p $DIR/$tdir
+
+       local f=$DIR/$tdir/$tfile
+       local fid=$(copy_file /etc/passwd $f)
+
+       changelog_setup
+
+       # block copytool operations to allow for HSM request to be
+       # submitted and file be unlinked (CDT will find object removed)
+       copytool_suspend
+
+       $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
+
+       # wait request to reach CT
+       wait_request_state $fid ARCHIVE STARTED
+
+       rm -f $f
+
+       copytool_continue
+
+       wait_request_state $fid ARCHIVE FAILED
+
+       local flags=$(changelog_get_flags ${MDT[0]} HSM $fid | tail -1)
+       changelog_cleanup
+
+       # HE_ARCHIVE|ENOENT
+       local target=0x2
+       [[ $flags == $target ]] || error "Changelog flag is $flags not $target"
+
+       copytool_cleanup
+}
+run_test 220a "Changelog for failed archive"
+
 test_221() {
        # test needs a running copytool
        copytool_setup
@@ -3888,7 +4348,7 @@ test_221() {
 
        local f=$DIR/$tdir/$tfile
        local fid
-       fid=$(make_large_for_cancel $f)
+       fid=$(make_custom_file_for_progress $f 103 1048576)
        [ $? != 0 ] && skip "not enough free space" && return
 
        changelog_setup
@@ -3959,6 +4419,72 @@ test_222b() {
 }
 run_test 222b "Changelog for implicit restore"
 
+test_222c() {
+       # test needs a running copytool
+       copytool_setup
+
+       mkdir -p $DIR/$tdir
+       copy2archive /etc/passwd $tdir/$tfile
+
+       local f=$DIR/$tdir/$tfile
+       import_file $tdir/$tfile $f
+       local fid=$(path2fid $f)
+
+       changelog_setup
+
+       # block copytool operations to allow for HSM request to be
+       # submitted and file be unlinked (CDT will find object removed)
+       copytool_suspend
+
+       $LFS hsm_restore $f
+
+       # wait request to reach CT
+       wait_request_state $fid RESTORE STARTED
+
+       rm -f $f
+
+       copytool_continue
+
+       wait_request_state $fid RESTORE FAILED
+
+       local flags=$(changelog_get_flags ${MDT[0]} HSM $fid | tail -1)
+
+       # HE_RESTORE|ENOENT
+       local target=0x82
+       [[ $flags == $target ]] || error "Changelog flag is $flags not $target"
+
+       cleanup
+}
+run_test 222c "Changelog for failed explicit restore"
+
+test_222d() {
+       # test needs a running copytool
+       copytool_setup
+
+       mkdir -p $DIR/$tdir
+       local f=$DIR/$tdir/$tfile
+       local fid=$(copy_file /etc/passwd $f)
+
+       changelog_setup
+       $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
+       wait_request_state $fid ARCHIVE SUCCEED
+       $LFS hsm_release $f
+
+       copytool_remove_backend $fid
+       md5sum $f
+
+       wait_request_state $fid RESTORE FAILED
+
+       local flags=$(changelog_get_flags ${MDT[0]} HSM $fid | tail -1)
+
+       # HE_RESTORE|ENOENT
+       local target=0x82
+       [[ $flags == $target ]] || error "Changelog flag is $flags not $target"
+
+       cleanup
+}
+run_test 222d "Changelog for failed implicit restore"
+
 test_223a() {
        # test needs a running copytool
        copytool_setup
@@ -3997,7 +4523,7 @@ test_223b() {
 
        local f=$DIR/$tdir/$tfile
        local fid
-       fid=$(make_large_for_progress $f)
+       fid=$(make_custom_file_for_progress $f 39 1000000)
        [ $? != 0 ] && skip "not enough free space" && return
 
        changelog_setup
@@ -4046,6 +4572,47 @@ test_224() {
 }
 run_test 224 "Changelog for remove"
 
+test_224a() {
+       # test needs a running copytool
+       copytool_setup
+
+       mkdir -p $DIR/$tdir
+
+       local f=$DIR/$tdir/$tfile
+       local fid=$(copy_file /etc/passwd $f)
+
+       changelog_setup
+       $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
+       wait_request_state $fid ARCHIVE SUCCEED
+
+       copytool_remove_backend $fid
+
+       # block copytool operations to allow for HSM request to be
+       # submitted and file be unlinked (CDT will find object removed)
+       copytool_suspend
+
+       $LFS hsm_remove $f
+
+       # wait for request to reach CT
+       wait_request_state $fid REMOVE STARTED
+
+       rm -f $f
+
+       copytool_continue
+
+       wait_request_state $fid REMOVE FAILED
+
+       local flags=$(changelog_get_flags ${MDT[0]} HSM $fid | tail -n 1)
+
+       # HE_REMOVE|ENOENT
+       local target=0x202
+       [[ $flags == $target ]] ||
+               error "Changelog flag is $flags not $target"
+
+       cleanup
+}
+run_test 224a "Changelog for failed remove"
+
 test_225() {
        # test needs a running copytool
        copytool_setup
@@ -4059,7 +4626,7 @@ test_225() {
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
        local fid
-       fid=$(make_large_for_progress $f)
+       fid=$(make_custom_file_for_progress $f 39 1000000)
        [ $? != 0 ] && skip "not enough free space" && return
 
        changelog_setup
@@ -4264,7 +4831,7 @@ test_251() {
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
        local fid
-       fid=$(make_large_for_cancel $f)
+       fid=$(make_custom_file_for_progress $f 103 1048576)
        [ $? != 0 ] && skip "not enough free space" && return
 
        cdt_disable
@@ -4293,6 +4860,43 @@ test_251() {
 }
 run_test 251 "Coordinator request timeout"
 
+test_252() {
+       # test needs a running copytool
+       copytool_setup
+
+       mkdir -p $DIR/$tdir
+       local f=$DIR/$tdir/$tfile
+       local fid=$(make_custom_file_for_progress $f 103 1048576)
+
+       cdt_disable
+       # to have a short test
+       local old_to=$(get_hsm_param active_request_timeout)
+       set_hsm_param active_request_timeout 20
+       # to be sure the cdt will wake up frequently so
+       # it will be able to cancel the "old" request
+       local old_loop=$(get_hsm_param loop_period)
+       set_hsm_param loop_period 2
+       cdt_enable
+
+       # clear locks to avoid extra delay caused by flush/cancel
+       # and thus prevent early copytool death to timeout.
+       cancel_lru_locks osc
+
+       $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
+       wait_request_state $fid ARCHIVE STARTED
+       rm -f $f
+
+       # wait but less than active_request_timeout+grace_delay
+       sleep 25
+       wait_request_state $fid ARCHIVE CANCELED
+
+       set_hsm_param active_request_timeout $old_to
+       set_hsm_param loop_period $old_loop
+
+       copytool_cleanup
+}
+run_test 252 "Timeout'ed running archive of a removed file should be canceled"
+
 test_300() {
        # the only way to test ondisk conf is to restart MDS ...
        echo "Stop coordinator and remove coordinator state at mount"
@@ -4441,7 +5045,7 @@ mdc_change_state() # facet, MDT_pattern, activate|deactivate
        done
 }
 
-test_402() {
+test_402a() {
        # make sure there is no running copytool
        copytool_cleanup
 
@@ -4458,7 +5062,34 @@ test_402() {
        # reactivate MDCs
        mdc_change_state $SINGLEAGT "$FSNAME-MDT000." "activate"
 }
-run_test 402 "Copytool start fails if all MDTs are inactive"
+run_test 402a "Copytool start fails if all MDTs are inactive"
+
+test_402b() {
+       copytool_setup
+
+       mkdir -p $DIR/$tdir
+
+       local f=$DIR/$tdir/$tfile
+       touch $f || error "touch $f failed"
+       local fid=$(path2fid $f)
+
+#define OBD_FAIL_MDS_HSM_CT_REGISTER_NET       0x14d
+       do_facet $SINGLEAGT lctl set_param fail_loc=0x14d
+       $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
+
+       # give time for CDT to send request and to keep it for retry
+       wait_for_loop_period
+
+       wait_request_state $fid ARCHIVE WAITING
+
+       do_facet $SINGLEAGT lctl set_param fail_loc=0
+
+       # request should succeed now
+       wait_request_state $fid ARCHIVE SUCCEED
+
+       copytool_cleanup
+}
+run_test 402b "CDT must retry request upon slow start of CT"
 
 test_403() {
        [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
@@ -4573,6 +5204,66 @@ test_405() {
 }
 run_test 405 "archive and release under striped directory"
 
+test_406() {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
+
+       [ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.7.64) ] &&
+               skip "need MDS version at least 2.7.64" && return 0
+
+       local fid
+       local mdt_index
+
+       copytool_setup
+       mkdir -p $DIR/$tdir
+       fid=$(make_small $DIR/$tdir/$tfile)
+       echo "old fid $fid"
+
+       $LFS hsm_archive $DIR/$tdir/$tfile
+       wait_request_state "$fid" ARCHIVE SUCCEED
+       $LFS hsm_release $DIR/$tdir/$tfile
+
+       # Should migrate $tdir but not $tfile.
+       $LFS mv -M1 $DIR/$tdir &&
+               error "migrating HSM an archived file should fail"
+
+       $LFS hsm_restore $DIR/$tdir/$tfile
+       wait_request_state "$fid" RESTORE SUCCEED
+
+       $LFS hsm_remove $DIR/$tdir/$tfile
+       wait_request_state "$fid" REMOVE SUCCEED
+
+       cat $DIR/$tdir/$tfile > /dev/null ||
+               error "cannot read $DIR/$tdir/$tfile"
+
+       $LFS mv -M1 $DIR/$tdir ||
+               error "cannot complete migration after HSM remove"
+
+       mdt_index=$($LFS getstripe -M $DIR/$tdir)
+       if ((mdt_index != 1)); then
+               error "expected MDT index 1, got $mdt_index"
+       fi
+
+       # Refresh fid after migration.
+       fid=$(path2fid $DIR/$tdir/$tfile)
+       echo "new fid $fid"
+
+       $LFS hsm_archive $DIR/$tdir/$tfile
+       wait_request_state "$fid" ARCHIVE SUCCEED 1
+
+       lctl set_param debug=+trace
+       $LFS hsm_release $DIR/$tdir/$tfile ||
+               error "cannot release $DIR/$tdir/$tfile"
+
+       $LFS hsm_restore $DIR/$tdir/$tfile
+       wait_request_state "$fid" RESTORE SUCCEED 1
+
+       cat $DIR/$tdir/$tfile > /dev/null ||
+               error "cannot read $DIR/$tdir/$tfile"
+
+       copytool_cleanup
+}
+run_test 406 "attempting to migrate HSM archived files is safe"
+
 test_500()
 {
        [ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.6.92) ] &&